<template>
  <div class="app-container">
    <!-- 搜索 -->
    <el-form inline size="mini">
      <el-form-item label="专辑名称：">
        <el-input v-model="form.name" placeholder="请输入专辑名称" clearable />
      </el-form-item>
      <el-form-item label="资源平台：">
        <el-select v-model="form.platformId" placeholder="请选择资源平台" clearable>
          <el-option v-for="item in platformOptions" :key="item.value" :value="item.value"
            :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="专辑类型：">
        <el-select v-model="form.albumType" placeholder="请选择专辑类型">
          <el-option v-for="item in albumTypeOptions" :key="item.value" :value="item.value"
            :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="付费类型：">
        <el-select v-model="form.payType" placeholder="请选择付费类型">
          <el-option v-for="item in payTypeOptions" :key="item.value" :value="item.value"
            :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="当前状态：">
        <el-select v-model="form.status" placeholder="请选择当前状态" clearable>
          <el-option v-for="item in onOrOffOptions" :key="item.value" :value="item.value"
            :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="getSearch">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="getRefresh">重置</el-button>
        <el-button type="primary" plain icon="el-icon-plus" @click="getDetail()">新增</el-button>
        <el-button type="primary" :disabled="obj.id === ''" @click="getChange(obj, 1)">批量上架</el-button>
        <el-button type="primary" :disabled="obj.id === ''" @click="getChange(obj, 2)">批量下架</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading" @selection-change="handleSelect">
      <el-table-column type="selection" align="center" />
      <el-table-column label="ID" prop="id" align="center" show-overflow-tooltip />
      <el-table-column label="专辑名称" prop="name" align="center" show-overflow-tooltip />
      <el-table-column label="专辑封面" align="center" width="100px">
        <template slot-scope="scope">
          <el-image v-if="scope.row.coverUrl" :src="scope.row.coverUrl" />
        </template>
      </el-table-column>
      <el-table-column label="专辑类型" prop="albumType" align="center" :formatter="typeFormatter" show-overflow-tooltip />
      <el-table-column label="付费类型" prop="payType" align="center" :formatter="payTypeFormatter" />
      <el-table-column label="歌曲数量" prop="programCount" align="center" />
      <el-table-column label="资源平台" prop="platformId" align="center" :formatter="platformFormatter" />
      <el-table-column label="当前状态" prop="status" align="center" :formatter="statusFormatter" />
      <el-table-column label="更新时间" prop="updateTime" align="center">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDetail(scope.row.id, true)">查看</el-button>
          <span v-if="scope.row.status === 2" style="margin: 0 10px">
            <el-button type="text" @click="getDetail(scope.row.id)">编辑</el-button>
            <el-button type="text" @click="getChange(scope.row, 1)">上架</el-button>
            <el-button type="delete" @click="getDelete(scope.row)">删除</el-button>
          </span>
          <el-button v-else type="text" @click="getChange(scope.row, 2)">下架</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total>0" :total="total" :page.sync="form.pageNum" :limit.sync="form.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>
import { list, change, remove } from '@/api/music/menu'
import { platformMixin, onOrOffMixin, payTypeMixin, albumTypeMixin } from '@/mixin/index'
export default {
  mixins: [platformMixin, onOrOffMixin, payTypeMixin, albumTypeMixin],
  data() {
    return {
      // 遮罩层
      loading: false,
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10,
        type: 1
      },
      // 总数据
      total: 0,
      // 列表
      tableData: [],
      // 批量上下架
      obj: {
        id: '',
        name: '已选数据'
      }
    }
  },
  mounted() {
    // 获取资源平台
    this.getPlatform(15)
    this.getList()
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      list(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data.records
          this.total = res.data.total
          this.loading = false
        }
      })
    },

    // 搜索
    getSearch() {
      this.form.pageNum = 1
      this.getList()
    },

    // 重置
    getRefresh() {
      this.form = {
        pageNum: 1,
        pageSize: 10,
        type: 1
      }
      this.getList()
    },

    // 新增 / 查看 / 编辑
    getDetail(id, boolean) {
      this.$router.push({
        path: `/music/album/detail`,
        query: {
          id: id,
          disabled: boolean
        }
      })
    },

    // 上下架
    getChange(row, status) {
      console.log(row);
      let title = status === 1 ? '上架' : '下架'
      this.$confirm(`是否${title}${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        change(row.id, status).then(res => {
          if (res.code === 0) {
            this.$message.success(`${title}成功！`)
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        remove(row.id).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 多选
    handleSelect(e) {
      this.obj.id = ''
      e.map((item, index) => this.obj.id += item.id + ((index + 1) < e.length ? ',' : ''))
    },

    // 字典翻译
    platformFormatter(row) {
      return this.selectDictLabel(this.platformOptions, row.platformId)
    },

    statusFormatter(row) {
      return this.selectDictLabel(this.onOrOffOptions, row.status)
    },

    typeFormatter(row) {
      return this.selectDictLabel(this.albumTypeOptions, row.albumType)
    },

    payTypeFormatter(row) {
      return this.selectDictLabel(this.payTypeOptions, row.payType)
    }
  },
};
</script>